# Contributor's Guidelines

Contributions are possible in form of Issues or Pull Requests.

For Issues, please:

1. Read the documentation and/or the README.
2. Search for your problem in the issues section first.
3. If you cannot find a solution/answer yourself with these resources, raise an issue.

For PRs:

1. Every PR must contain a passing unit-test or an adaption of existing tests that tests the proposed changes. All existing tests must pass.
2. Keep your commits small.
3. document your code, preferably with Google style docstrings (https://sphinxcontrib-napoleon.readthedocs.io/en/latest/example_google.html),
   at least though with intuitive comments
4. keep your code as readable as possible (https://docs.python-guide.org/writing/style/) and
5. compliant with flake8 (http://flake8.pycqa.org/en/latest/index.html#)

By submitting a pull request to this repository, you agree to license your contribution under the MIT license of this project.

By contributing you agree to follow the [Code of Conduct of this project](CODE_OF_CONDUCT.md). The project owner(s) reserve the right to exclude/ban contributors from this project not only, but especially if they violate the CoC.
